<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle">
      <el-row>
        <div class="el-row-button-input">
          <label>
            {{ $t('nav.usermanagement') }}
          </label>
          <el-button
            id="addUserBtn"
            style="float:right;"
            type="primary"
            @click="addUser"
          >
            <em class="el-icon-user" />
            {{ $t('user.addUsrBtn') }}
          </el-button>
          <el-button
            id="batchDltBtn"
            style="float:right;margin-right: 15px"
            type="primary"
            @click="confirmDeleteUser()"
            :disabled="selectedRowIds.length === 0 || isAdmin"
          >
            <em class="el-icon-delete" />
            {{ $t('user.batchDltBtn') }}
          </el-button>
          <el-button
            id="guestconfirguration"
            style="float:right;margin-right: 15px"
            type="primary"
            @click="showConfigurationDialog = true"
          >
            <em class="el-icon-edit" />
            {{ $t('nav.addguestlink') }}
          </el-button>
        </div>
      </el-row>
    </div>
    <div class="userList">
      <SearchUser
        @getSearchData="getSearchData"
      />
      <div class="tableDiv">
        <el-row>
          <el-col
            :span="24"
            class="table"
          >
            <el-table
              v-loading="dataLoading"
              :data="currPageTableData"
              border
              @selection-change="handleSelectionChange"
            >
              <el-table-column
                type="selection"
                width="55"
              />
              <el-table-column
                prop="username"
                :label="$t('user.username')"
              />
              <el-table-column
                prop="role"
                :label="$t('user.role')"
              />
              <el-table-column
                prop="company"
                :label="$t('user.company')"
              />
              <el-table-column
                prop="companyAddress"
                :label="$t('user.location')"
              />
              <el-table-column
                prop="email"
                :label="$t('user.email')"
              />
              <el-table-column
                prop="isAllowed"
                :formatter="cellValueRenderer"
                :label="$t('env.isAllowed')"
              />
              <el-table-column
                :label="$t('common.operation')"
                width="180"
              >
                <template slot-scope="scope">
                  <el-button
                    id="editUsrBtn"
                    @click="modifyUser(scope.row)"
                    type="text"
                    size="small"
                    :disabled="scope.row.role.toLowerCase() === 'administrator'"
                  >
                    {{ $t('user.edit') }}
                  </el-button>
                  <el-button
                    id="dltUsrBtn"
                    @click="confirmDeleteUser(scope.row)"
                    type="text"
                    size="small"
                    :style="[scope.row.role.toLowerCase() === 'administrator' ? {'color': ''} : {'color': 'red'}]"
                    :disabled="scope.row.role.toLowerCase() === 'administrator'"
                  >
                    {{ $t('user.delete') }}
                  </el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-col>
        </el-row>
        <div class="pageBar">
          <Pagination
            :table-data="paginationData"
            @getCurrentPageData="getCurrentPageData"
          />
        </div>
        <GuestConfiguration
          v-if="showConfigurationDialog && !dialogVisible"
          :visible="showConfigurationDialog"
          :config-data="configurationData"
          @cancelConfiguration="cancel"
        />
        <el-dialog
          :title="isAddUser ? $t('user.addUsrBtn') : 'Modify User'"
          :visible.sync="dialogVisible"
          v-loading="loading"
        >
          <el-form
            label-width="180px"
          >
            <div style="margin-top: 15px;">
              <el-form-item
                :label="$t('user.username')"
              >
                <el-input
                  type="text"
                  v-model="currentRowData.username"
                  :readonly="!this.isAddUser"
                />
              </el-form-item>
            </div>
            <div style="margin-top: 15px;">
              <el-form-item
                :label="$t('user.role')"
              >
                <el-select
                  id="role"
                  style="width:100%"
                  v-model="currentRowData.role"
                  default-first-option
                >
                  <el-option
                    v-for="item in options"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                  />
                </el-select>
              </el-form-item>
            </div>
            <div style="margin-top: 15px;">
              <el-form-item
                :label="$t('user.company')"
              >
                <el-input
                  type="text"
                  v-model="currentRowData.company"
                />
              </el-form-item>
            </div>
            <div style="margin-top: 15px;">
              <el-form-item
                :label="$t('user.location')"
              >
                <el-input
                  type="text"
                  v-model="currentRowData.companyAddress"
                />
              </el-form-item>
            </div>
            <div style="margin-top: 15px;">
              <el-form-item
                :label="$t('user.email')"
              >
                <el-input
                  type="text"
                  v-model="currentRowData.email"
                />
              </el-form-item>
            </div>
            <div style="margin-top: 15px;">
              <el-form-item
                :label="$t('env.isAllowed')"
              >
                <el-select
                  id="role"
                  style="width:100%"
                  v-model="currentRowData.isAllowed"
                  default-first-option
                >
                  <el-option
                    v-for="item in isAllowedOptions"
                    :label="item"
                    :value="item"
                    :key="item"
                  />
                </el-select>
              </el-form-item>
            </div>
          </el-form>
          <div
            slot="footer"
            class="dialog-footer"
          >
            <el-button
              id="cancelBtn"
              @click="cancel()"
            >
              {{ $t('common.cancel') }}
            </el-button>
            <el-button
              id="confirmBtn"
              type="primary"
              @click="confirm()"
              :loading="loading"
            >
              {{ $t('common.confirm') }}
            </el-button>
          </div>
        </el-dialog>
      </div>
    </div>
  </div>
</template>

<script>
import SearchUser from '../components/SearchUser.vue'
import GuestConfiguration from './GuestConfiguration.vue'
import Pagination from '../components/Pagination.vue'
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'
export default {
  name: 'UserManagement',
  components: {
    SearchUser,
    Pagination,
    GuestConfiguration
  },
  data () {
    return {
      selectedRowIds: [],
      isAdmin: false,
      dataLoading: true,
      tableData: [],
      paginationData: [],
      currPageTableData: [],
      edgeNodesData: [],
      dialogVisible: false,
      packageSearchInput: '',
      edgeNodeSearchInput: '',
      edgeNodeCurrentPage: 1,
      edgeNodePageSize: 5,
      rowSelection: [],
      selectedNum: 0,
      nodeSelection: [],
      selectedNodeNum: 0,
      currentRowData: {
        username: '',
        role: '',
        company: '',
        companyAddress: '',
        telephone: '',
        email: ''
      },
      isAllowedOptions: [true, false],
      appType: '',
      loading: false,
      version: '',
      dialogLoading: false,
      appId: '',
      isAddUser: false,
      options: [
        {
          label: 'Administrator',
          value: 'administrator'
        },
        {
          label: 'App Developer',
          value: 'appdeveloper'
        }
      ],
      showConfigurationDialog: false,
      configurationData: {}
    }
  },
  mounted () {
    this.appType = this.$route.query.type ? this.$route.query.type : ''
    this.getUserDataList()
    this.getConfiguration()
  },
  computed: {
  },
  methods: {
    cellValueRenderer (row, column, cellValue, index) {
      let value = cellValue
      if (typeof row[column.property] === 'boolean') {
        value = String(cellValue)
      }
      return value
    },
    async getConfiguration () {
      let url = BASE_URL + '/getGuestConfiguration'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.configurationData = res.data
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    addUser () {
      this.currentRowData = {}
      this.dialogVisible = true
      this.isAddUser = true
    },
    getSearchData (data) {
      this.getUserDataList(data)
    },
    getCurrentPageData (data) {
      this.currPageTableData = data
    },
    handleSelectionChange (val) {
      this.isAdmin = false
      this.selectedRowIds = []
      this.rowSelection = val
      this.selectedNum = val.length
      for (let i = 0; i < val.length; i++) {
        if (val[i].role.toLowerCase() === 'administrator') {
          this.isAdmin = true
          return
        }
        this.selectedRowIds.push(val[i].userId)
      }
    },
    handleEdgeNodeSelectionChange (val) {
      this.nodeSelection = val
      this.selectedNodeNum = val.length
    },
    modifyUser (user) {
      this.dialogVisible = true
      this.currentRowData = user
    },
    async getUserDataList (data) {
      if (!data) {
        data = {
          username: '',
          role: 'ALL'
        }
      }
      let url = `${BASE_URL}/getUser?username=${data.username}&role=${data.role}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationData = res.data
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    handleEdgeNodePageSizeChange (edgeNodePageSize) {
      this.edgeNodePageSize = edgeNodePageSize
    },
    handleEdgeNodeCurrentPageChange (edgeNodeCurrentPage) {
      this.edgeNodeCurrentPage = edgeNodeCurrentPage
    },
    cancel () {
      this.dialogVisible = false
      this.isAddUser = false
      this.showConfigurationDialog = false
    },
    async confirm () {
      let url = BASE_URL + '/addUser'
      let type = 'POST'
      if (!this.isAddUser) {
        url = BASE_URL + '/modifyUser'
        type = 'PUT'
      }
      axios({
        method: type,
        url: url,
        data: this.currentRowData,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.addUserSuccess'))
        this.getUserDataList()
        this.cancel()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    confirmDeleteUser (row) {
      this.$confirm(this.$t('confirm.confirmToDeleteUser'), this.$t('common.warning'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      }).then(() => {
        if (row) {
          this.deleteUser(row)
        } else {
          this.batchDeleteUser()
        }
      })
    },
    async deleteUser (row) {
      let url = BASE_URL + '/deleteUser?userId=' + row.userId
      axios({
        method: 'DELETE',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteUserSuccess'))
        this.getUserDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    async batchDeleteUser () {
      let url = BASE_URL + '/userBatchDelete'
      axios({
        method: 'DELETE',
        url: url,
        data: { 'userIds': this.selectedRowIds },
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteBatchUserSuccess'))
        this.selectedRowIds = []
        this.getUserDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 5% 1% 5%;
  font-weight: bold;
}
.userList {
    margin: 0 5%;
    height: 100%;
    background: #fff;
    padding: 30px 0px;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
    height:40px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
